`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////////////////
// Joystick Controller
// Engineer: Kiselev I.
// 
// Create Date:    15/05/2015
//
// Revision History: 
// 						Revision 0.01 - File Created (Josh Sackos)
////////////////////////////////////////////////////////////////////////////////////////////

// ==============================================================================
// 										  Define Module
// ==============================================================================
module Joystick(
			input CLK,
			input RST,
			input MISO,
			output SS,
			output SCLK,
			output MOSI,
			output UP,
			output DOWN,
			output LEFT,
			output RIGHT
    );

localparam THRESH_UP 	= 550;
localparam THRESH_DOWN 	= 380;
localparam THRESH_LEFT 	= 560;
localparam THRESH_RIGHT = 390;

wire [7:0] DIN = 8'd0;		// Data that is to be sent to the slave

wire [39:0] jstkData;
wire [9:0] pos_x;
wire [9:0] pos_y;

// Signal to send/receive data to/from PmodJSTK
wire sndRec;

//-----------------------------------------------
//  			 Send Receive Generator
//-----------------------------------------------
ClkDiv_50Hz genSndRec(
		.CLK(CLK),
		.RST(RST),
		.CLKOUT(sndRec)
);

PmodJSTK JoyStickPMOD(
	.CLK(CLK),
	.RST(RST),
	.sndRec(sndRec),
	.DIN(din),
	.MISO(MISO),
	.SS(SS),
	.SCLK(SCLK),
	.MOSI(MOSI),
	.DOUT(jstkData)
	);
	
assign pos_x = {jstkData[9:8], jstkData[23:16]};
assign pos_y = {jstkData[25:24], jstkData[39:32]};	
assign UP = (pos_y > THRESH_UP);
assign DOWN = (pos_y < THRESH_DOWN);
assign LEFT = (pos_x > THRESH_LEFT);
assign RIGHT = (pos_x < THRESH_RIGHT);
 
endmodule
